package com.example.cristiano.aninterface;

import android.os.AsyncTask;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ListView;
import android.widget.Toast;

import java.util.ArrayList;

public class MainActivity extends AppCompatActivity {

    private char placeNumber;
    private ListView mList;
    private ArrayList<String> arrayList;
    private MyCustomAdapter mAdapter;
    private TCPClient mTcpClient;

    @Override
    public void onCreate(Bundle savedInstanceState)
    {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        //arrayList = new ArrayList<String>();

        //final EditText editText = (EditText) findViewById(R.id.editText);
        Button go = (Button)findViewById(R.id.goButton);

        Button p1 = (Button) findViewById(R.id.p1_button);
        Button p2 = (Button) findViewById(R.id.p2_button);
        Button p3 = (Button) findViewById(R.id.p3_button);
        Button p4 = (Button) findViewById(R.id.p4_button);


        p1.setOnClickListener(new View.OnClickListener(){
            public void onClick(View v){
                //Enviar mensagem para dragonBoard (processamento)
                placeNumber = 'A';
                Toast.makeText(MainActivity.this,"PLACE " + placeNumber + " SELECTED", Toast.LENGTH_LONG).show();
            }
        });

        p2.setOnClickListener(new View.OnClickListener(){
            public void onClick(View v){
                //Enviar mensagem para dragonBoard (processamento)
                placeNumber = 'B';
                Toast.makeText(MainActivity.this,"PLACE " + placeNumber + " SELECTED", Toast.LENGTH_LONG).show();
            }
        });

        p3.setOnClickListener(new View.OnClickListener(){
            public void onClick(View v){
                //Enviar mensagem para dragonBoard (processamento)
                placeNumber = 'C';
                Toast.makeText(MainActivity.this,"PLACE " + placeNumber + " SELECTED", Toast.LENGTH_LONG).show();
            }
        });

        p4.setOnClickListener(new View.OnClickListener(){
            public void onClick(View v){
                //Enviar mensagem para dragonBoard (processamento)
                placeNumber = 'D';
                Toast.makeText(MainActivity.this,"PLACE " + placeNumber + " SELECTED", Toast.LENGTH_LONG).show();
            }
        });

        //relate the listView from java to the one created in xml
        //mList = (ListView)findViewById(R.id.list);
        //mAdapter = new MyCustomAdapter(this, arrayList);
        //mList.setAdapter(mAdapter);

        // connect to the server
        new connectTask().execute("");

        go.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                String message = "PLACE_"+placeNumber;

                //add the text in the arrayList
                //arrayList.add("c: " + message);

                //sends the message to the server
                if (mTcpClient != null) {
                    mTcpClient.sendMessage(message);
                }

                //refresh the list
                //mAdapter.notifyDataSetChanged();
                //editText.setText("");
            }
        });

    }

    public class connectTask extends AsyncTask<String,String,TCPClient> {

        @Override
        protected TCPClient doInBackground(String... message) {

            //we create a TCPClient object and
            mTcpClient = new TCPClient(new TCPClient.OnMessageReceived() {
                @Override
                //here the messageReceived method is implemented
                public void messageReceived(String message) {
                    //this method calls the onProgressUpdate
                    publishProgress(message);
                }
            });
            mTcpClient.run();

            return null;
        }

        @Override
        protected void onProgressUpdate(String... values) {
            super.onProgressUpdate(values);

            //in the arrayList we add the messaged received from server
            arrayList.add(values[0]);
            // notify the adapter that the data set has changed. This means that new message received
            // from server was added to the list
            mAdapter.notifyDataSetChanged();
        }
    }
}

